﻿Imports System.Data.SqlClient

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            Me.BindGrid()
        End If
    End Sub

    Private Sub BindGrid()
        gvCustomers.DataSource = Me.PopulateData()
        gvCustomers.DataBind()
    End Sub

    Private Function PopulateData() As List(Of CustomerVB)
        Dim customers As List(Of CustomerVB) = New List(Of CustomerVB)()
        Dim query As String = "SELECT CustomerID, ContactName, City, Country FROM Customers"
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As SqlConnection = New SqlConnection(constr)
            Using cmd As SqlCommand = New SqlCommand(query, con)
                con.Open()
                Using sdr As SqlDataReader = cmd.ExecuteReader()
                    While sdr.Read()
                        customers.Add(New CustomerVB With {
                            .CustomerId = sdr("CustomerID").ToString(),
                            .ContactName = sdr("ContactName").ToString(),
                            .City = sdr("City").ToString(),
                            .Country = sdr("Country").ToString()
                        })
                    End While
                End Using
                con.Close()
            End Using
        End Using
        Return customers
    End Function

    Protected Sub OnPaging(ByVal sender As Object, ByVal e As GridViewPageEventArgs)
        gvCustomers.PageIndex = e.NewPageIndex
        Me.BindGrid()
    End Sub

End Class
